#include <bits/stdc++.h> // all C/C++ libs
using namespace std;

int N, M;

struct Edge {
	int a,b,c;
	Edge *rev;
};

vector<Edge *> A[100000];
int depth[1000000];
int ptr[1000000];

void addEdge(int a, int b, int c) {
	Edge *e = new Edge{a,b,c}, *re = new Edge{b,a,0};
	e->rev = re;
	re->rev = e;
	A[a].push_back(e);
	A[b].push_back(re);
}

int bfs(int s, int t) {
	fill(depth,depth+N,N);
	deque<int> Q;
	Q.push_back(s);
	depth[s] = 0;
	while(!Q.empty()) {
		int a = Q.front();
		Q.pop_front();
		for(auto e: A[a]) {
			if(depth[e->b] < N || e->c == 0) continue;
			Q.push_back(e->b);
			depth[e->b] = depth[e->a] + 1;
			if(e->b == t) return 1;
		}
	}
	return 0;
}

long long dfs(int a, int t, int flow = -1) {
    //Use dfs to push flow on all shortest paths simultaneously
	if(a == t) return flow;
	if(flow == -1) fill(ptr,ptr+N,0);
    //The ptr optimization is important so that next time we don't try sending flow to already explored paths
	long long total = 0;
	for(; ptr[a]<A[a].size(); ptr[a]++) {
		auto e = A[a][ ptr[a] ];
		if( e->c == 0  || depth[e->b] != depth[e->a] + 1 ) continue;
		int send = e->c;
		if( flow >= 0 && send > flow - total ) send = flow-total;
		int sent = dfs(e->b, t, send);
		e->c 	  	-= sent;
		e->rev->c 	+= sent;
		total 		+= sent;
		if(flow == total) break;
	}
	return total;
}

long long flow(int s, int t) {
	long long total = 0;
	while(bfs(s,t)) total += dfs(s,t);
	return total;
}

int main() {
	cin>>N>>M;
	for(int i=0;i<M;i++) {
		int a,b,c;
		cin>>a>>b>>c;
		addEdge(a-1,b-1,c);
	}
	cout<<flow(0,N-1)<<endl;
	return 0;
}